
global object void -- used as ubiquitous assignee

-- low level functions

global function null_bits(integer n, integer nullbit)
	n = or_bits(n, nullbit)
	n = xor_bits(n, nullbit)
	return n
	end function

global function or_all(object s) -- or together all elements of a sequence
	atom result
	if atom(s) then
		return s
	end if
	result = 0
	for i = 1 to length(s) do
		result = or_bits(result, s[i])
	end for
	return result
	end function


--global function aggregate(integer n, integer d)
--	-- fill out the integer to the nearest upper multiple of d
--	-- assumes 1-based convention and the numbers must be +ve
--	n -= 1
--	n += d - remainder(n, d)
--	return n	
--	end function


-----------------------------------



global function hiWord(atom dWord)
	return floor(dWord/#10000)
	end function


global function loWord(atom dWord)
	return and_bits(dWord, #FFFF)
	end function


global procedure poke2(atom addr, object x)
	if integer(x) then
		if x < 0 then
			x += 65536
		end if	
		poke(addr, x) -- note: only the lower 8 bits are stored
		poke(addr+1, floor(x/256))
	else -- sequence
		for i = 1 to length(x) do
			poke2(addr+i-1, x[i])
		end for
	end if
	end procedure


global function peek2u(atom addr)
	return peek(addr) + peek(addr+1) * 256
	end function


global function peek2s(atom addr)
	integer word
	word = peek(addr) + peek(addr+1) * 256
	if word > 32767 then
		word -= 65536
	end if
	return word
	end function


global function peek8u(atom addr)
	atom num
	num = peek4u(addr) + peek4u(addr+4) * power(2, 32)
	return num
	end function


global function peek_string(atom addr)
	atom last

	-- initialize variables
	last = addr

	-- find end of string
	while peek(last) do
		last += 1
	end while

	-- get the string
	return peek( {addr, last - addr} )

	end function


global function peek_string_zz(atom addr)
	sequence text, strings

	strings = {}
	
	while peek(addr) do
		text = peek_string(addr)
		strings = append(strings, text)
		addr += length(text) + 1		
	end while

	-- special case where NO strings were found in that, technically, the
	-- first NULL represents an empty string
	if not length(strings) then
		strings = { "" }
	end if

	return strings

	end function

constant CASEDISPLACEMENT = 'a' - 'A'

global function upper(object s)
	if atom(s) then
		if s >= 'a' then
			if s <= 'z' then
				return s - CASEDISPLACEMENT
			end if
		end if
		return s
	end if
	for i = 1 to length(s) do
		s[i] = upper(s[i])
	end for
	return s
	end function


--/////////////////////// dir function/s

function extractPath(sequence pathname)
-- extract path from an absolute or relative pathname
	integer char
	for i = length(pathname) to 1 by -1 do
		char = pathname[i]
		if char = '\\'  or char = '/' then -- delimiter found
			return pathname[1..i]
		end if
	end for
	return ""
	end function


global function getProgDir()
-- Returns the directory that the executable program is residing in.
-- Does *not* return the Euphoria interpreter path.
	sequence s
	s = command_line()
	s = s[2]
	s = extractPath( s )
	return s
	end function


